#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include <stdint.h>

const int NUM_THREADS = 5;
pthread_key_t key;

int min(int a, int b) {
  return ((a<b) ? a : b);
}

void *thread_worker(void *data) {
  void *value;
  int i = (int) data;
  int j;
  int ret;
  int mintime;

  ret = pthread_setspecific(key, (void*) INT32_MAX);
  for(j=0; j<5; j++) {
    int sleep_time_micros = ((rand() % 1000) + 1) * 1000;

    mintime = (int) pthread_getspecific(key);
    mintime = min(mintime, sleep_time_micros);

    ret = pthread_setspecific(key, (void*) mintime);

    usleep(sleep_time_micros);

    printf ("Thread %d Worker %d %d \n", i, j, sleep_time_micros);
  }

  mintime = (int) pthread_getspecific(key);
  printf ("Thread %d Worker mintime %d \n", i, mintime);
}


int main(int argc, char* argv[]) {
  int i;
  int ret;
  pthread_t thread[NUM_THREADS];
  void *threadrc[NUM_THREADS];

  srand(time(NULL));
  /* key create without destructor */
  ret = pthread_key_create(&key, NULL);

  for (i=0; i < NUM_THREADS; i++) { 
    pthread_create(&thread[i], NULL, thread_worker, (void *) i);
  }

  for (i=0; i < NUM_THREADS; i++) { 
    pthread_join(thread[i], &threadrc[i]);
  }

  ret = pthread_key_delete(key);
}
